/*/
	Centrale D17

	Cette centrale DCC genere:
	- un signal DCC pour conduire ou programmer des locomotives numeriques
	- ou un signal PWM (+sens) pour une locomotive analogique
	La centrale pilote aussi des IO
	- en sortie: aiguillages, led, sorties, pwm, servos, decodeurs d'accessoires basiques et etendus
	- en entree: entrees numeriques d'un bus S88, et courant du booster
	Les ordres sont transmis par des clients TCP/IP qui se connectent via le Wifi integre.

	historique:
	- 2019/04/08: Ulysse Delmas-Begue  Correction d'un bug dans le protocole D17 wifi qui affecté les fonctions auxiliaires >= 10. N'affectait pas D17++
	- 2019/03/15: Jean-Michel Dubois   Ajout de la transmission de l'état des feux.
	- 2019/03/05: Ulysse Delmas-Begue  Support de CDM Rail avec le protocole DCC++
	- 2019/03/01: Jean-Michel Dubois   Projet renomme D17pp pour faciliter les discussions.
	- 2019/02/28: Jean-Michel Dubois   Transmission des pas DCC au lieu d'un pourcentage en protocole v2 et v3.
	- 2019/02/26: Jean-Michel Dubois   Adoption de la gestion par slots et des adresses DCC longues.
									   Ajout de limites bidirectionnelles de vitesse par zone avec les vitesses standards de la SNCF : 15, 30, 60, 90, 100, 120, 160, 220, 300 et 320 km/h.
									   Nouvelle interface de gestion des profils des trains.
									   Ajout dans le profil des trains des pas de vitesse DCC correspondant aux vitesses ci-dessus.
									   Envoi du profil des trains à D17 à la connexion.
									   Régulation automatique de la vitesse des trains en fonction de la limite de la zone et du profil du train.
	- 2019/02/25: Ulysse Delmas-Begue  Correction de bugs (envoie des adresses longues,  protocole desktop station, analogwrite)
	- 2019/02/22: Ulysse Delmas-Begue  Ajout des adresses longues 0-10239
	- 2019/02/21: Ulysse Delmas-Begue  Possibilité de connecter 8 clients wifi (qui peuvent etre sur des appareils differents)
									   contre 4 auparavant (ce nombre est parametrable et mis a 4 par defaut)
	- 2019/02/21: Ulysse Delmas-Begue  Passage de 2 locos max a 4 locos max par souris (pour etre compatible avec JM)
	- 2019/02/21: Ulysse Delmas-Begue  Passage aux slots
	- 2019/01/30: Ulysse Delmas-Begue  Ajout du protocol Desktop Station
	- 2019/02/14: Jean-Michel Dubois   Ajout des vitesses de régulation 15 et 160 km/h
									   La libération de zone n'était signalée qu'au client effectuant la première demande de statut après la libération
	- 2019/02/13: Jean-Michel Dubois   Distinction logique entre les 3 niveaux de protocole : v1 et v2 ne requièrent pas de code spécifique au réseau physique.
									   Moins de boutons, passage des commandes peu fréquentes dans les menus.
									   Courbe de vitesse par logiciel.
									   Mesure de vitesse accessible en protocole v2.
									   Les souris clientes transmettent au serveur la configuration des trains.
	- 2019/02/12: Jean-Michel Dubois   Code compilable pour un niveau de protocole maximal.
									   Négotiation du niveau de protocole entre le serveur et les stations clientes.
	- 2019/02/11: Jean-Michel Dubois   APMODE 1 ne fonctionnait pas.
									   Ajout de la mesure de vitesse.
	- 2019/02/10: Jean-Michel Dubois   Jonctions de trains.
									   Scission de train.
									   Possibilité d'avoir deux trains dans une zone pour les deux opérations ci-dessus.
	- 2019/01/20: Jean-Michel Dubois   Ajout de commentaires
	- 2019/01/15: Jean-Michel Dubois   Support de 4 souris par client
	- 2018/11/06: Jean-Michel Dubois   Ajout du support des MCP23017 en entrée et sortie
	- 2018/11/04: Jean-Michel Dubois   Ajout du support des modules de feux à base de MAX7219
									   Ajout du suivi des trains
									   Ajout du Block Automatique Lumineux simplifié dans user.cpp
									   Ajout de macros de commandes des accessoires
									   Affichage de la configuration matérielle sur le port série
	- 2018/11/01: Jean-Michel Dubois   Découpage du code source en modules
	- 2018/03/23: Ulysse Delmas-Begue  Passage des preambules à 16 "1" sur les conseils de JM afin de restpecter la norme NEM671
									   Il semblerait que ca fasse du bien a certains decodeurs recents
	- 2018/03/08: Ulysse Delmas-Begue  Merge des changements de JM
	- 2018/03/07: Jean-Michel Dubois   Proposition pour les changements suivants:
									   - Ajout du support du mode station (en plus du mode point d'accès)  --> DONE
									   - Generation des trames DCC plus claire                             --> DONE
									   - Ajout d'un mode pour gérer différement les fonctions auxiliaires  --> DONE
										 (car les mises a jour permanentes des fonctions posent des problemes aux decodeurs ESU pour les sons)
									   - Ajout des pointeurs pour simplifier la lisibilite du code         --> TBD
	- 2018/02/22: Ulysse Delmas-Begue  Ajout du protocole DCC++ (light) pour connecter la centrale a RocRail par exemple
	- 2017/02/13: Ulysse Delmas-Begue  Ajout du choix de la polarite du bouton d'arret d'urgence
									   Memorisation des entrees pour chaque souris afin de ne pas manquer les contacts fugitifs comme les ILS tres utile pour le mode script)
									   Limitation a une seule reponse de demande de status par souris et par boucle (afin de ne pas surcharger le wifi)
									   Choix de la commande des decodeurs d'accessoires en DCC (interdir, ok mais avec booster inactif, OK avec booster actif)
	- 2017/02/08: Ulysse Delmas-Begue  Ajout de la rotation lente des servos
	- 2018/02/07  Ulysse Delmas-Begue  Ajout du mode 126 crans en DCC. Vous pouvez choisir entre le mode 28 crans ou 126 crans (28 crans par defaut)
									   Ajout d'un facteur pour diminuer la plage PWM en analogique si vous utilisez une alim > 12V
	- 2018/01/31  Ulysse Delmas-Begue  Passage de la resolution des tempos de 20ms a 250ms car on ne pouvait pas tenir cette resolution et les pca/led ne sont mis a jour que toute les 250ms
									   La mise a jour des pca9685 est maintenant faite uniquement toute les 250ms (et seulement sur les canaux necessaires)
									   Ajout d'un bit 0 au signal dcc lorsque la boucle peut prendre trop de temps afin de rester dans les tolerances de la norme DCC (bit0 = 10ms max par état, 12ms au total)
	- 2018/01/29  Ulysse Delmas-Begue  Ajout du bouton d'arrêt d'urgence sur D5
									   Retrait temporaire de la variation lente des servos
	- 2018/01/22  Ulysse Delmas-Begue  Ajout de la commande u
									   Ajout a l'etat des variables u
									   Ajout de l'environement user de D18
									   Optimisation de la transmission des fonctions auxiliaires f1+f2-f3+... -> f1+-+
	- 2018/01/21  Ulysse Delmas-Begue  Rajout de la commande des decodeurs d'accessoires etendus
	- 2018/01/18  Ulysse Delmas-Begue  Test avec le decodeur d'accessories D18
	- 2018/01/07  Ulysse Delmas-Begue  Test avec TCO sur tablette pour in et aig ok
	- 2018/01/06  Ulysse Delmas-Begue  La LED "sign of life" peut etre dispo maintenant sur le max
									   Rajout de la commande des decodeurs d'accessoirs basiques
									   Ajout d'une commande pour identifier la centrale
	- 2018/01/05  Ulysse Delmas-Begue  Passage a 96entrees, 128leds, 48srv/pwm
									   Rajout de la commande des leds/srv/pwm par wifi
									   Rajout variation lente des servos
	- 2017/12/29  Ulysse Delmas-Begue  Ajout des fonctions F13-F28
									   Ajout des packets de 3bytes DCC (en plus du preambule et checksum)
									   Ajout de la commande des decodeurs d'accesoires DCC
	- 2017/12/27  Ulysse Delmas-Begue  Passage de 0-28 crans a 0-100% pour les souris
									   Ajout des fonctions F5-F12 (elle ne sont transmises que lorsque necessaire pour ne pas perdre de la bande passante)
									   Ajout d'un second canal dcc pour chaque souris pr piloter 2 locos simultanees par souris
	- 2017/12/26  Ulysse Delmas-Begue  Ajout de l'I2C afin de proposer 16 PWM ou SRV par PCA9685 (16)
									   Ajout du S88 (64)
	- 2017/12/24  Ulysse Delmas-Begue  Ajout des leds (64)
	- 2017/12/23  Ulysse Delmas-Begue  Ajout programation des CV
	- 2017/12/22  Ulysse Delmas-Begue  Ajout (temporaire) de 6 sorties controlees par le wifi
	- 2017/12/21  Ulysse Delmas-Begue  Correctif la centrale ne plante plus en DCC
									   Gere les passages entre DCC et ANA.
									   Ajout de la mesure du courant
	- 2017/12/16  Ulysse Delmas-Begue  Genere un signal PWM pour une locomotive ANAlogique en fonction d'une souris wifi
									   Passage de 1kHz a 20KHz afin de rendre la PWM inaudible
	- 2017/06/27  Ulysse Delmas-Begue  Creation: Genere un signal DCC en fonction de 4 souris wifi max

	a faire:
	- ajouter sur tablette appli de test pour servo, pwm, led, in, aig, acc   <-- ersatz pour l'instant avec msg
	- ajouter gestion des aiguillage  <-- ersatz pour l'instant
	- souris 1 changer les boutons
	- ID a la connection IP
	- voir combien de souris on peut avoir si D17 est en mode station
	- mettre le choix FCT_AUX_REPEAT au niveau des decodeurs, plutot qu'au niveau global.
	- idem pour le mode 126 crans
	- supporter le protocole D17 sur l'USB
	- supporter le protocle DesktopStation sur le WIFI
	- supporter le protocole DCC++ sur le WIFI
	- voir si possible de supporter plusieurs protocoles en // sur le WIFI (peut etre en ayant plusieurs serveurs sur des ports differents)

	a voire ???:
	- ajout d'itineraires           <-- ersatz pour l'instant
	- gestion de la signalisation   <-- ersatz pour l'instant
	- gestion de l'automatisation   <-- ersatz pour l'instant
	- voir si on passe la boucle de 250ms à 125ms comme sur le D18  <-- pas pour l'instant, necessaire de faire des tests de perf avant
	- voir, si on met plus de leds et pca comme sur le D18
	- voir si on met plus d'entrees
	- arreter les locos d'un e souris qui ne donne plus de signe de vie (plus de demande de status)
	- si pb de captage, peut rater des mises a 0 de fct auxiliaires car une seule transmission

	bugs
	- aucun

	notes:
	- La centrale demarre en AU avec le booster desactive
	- Si une souris utilise l'adrresse 1, la centrale passe en mode analogique ANA (PWM)
	- Si aucune souris n'utilise l'adresse 1, la centrale passe en mode DCC
	- Si le mode (DCC ou ANA) n'est pas autorise, la centrale passe quand meme dans ce mode mais se met en AU
	- Pour inactiver une souris, selectionner l'adresse 0 ou deconnectez la du wifi
	- Le programme ne doit pas bloquer la stack wifi pendant plus de 50ms (ajouter yield(0); or yield();)

		From: https://github.com/adafruit/ESP8266-Arduino
		Remember that there is a lot of code that needs to run on the chip besides the sketch when WiFi is connected.
		WiFi and TCP/IP libraries get a chance to handle any pending events each time the loop() function completes, OR when delay(...) is called.
		If you have a loop somewhere in your sketch that takes a lot of time (>50ms) without calling delay(),
		you might consider adding a call to delay function to keep the WiFi stack running smoothly.
		There is also a yield() function which is equivalent to yield().
		The delayMicroseconds function, on the other hand, does not yield to other tasks, so using it for delays more than 20 milliseconds is not recommended.

	- La centrale utilise maintenant une liste de slots. Chaque slot peut contenir les parametres pour une locomotive (adresse, sens, vitesse, fonctions auxilaiaire)
	Les slots sont émis en permanence et en boucle. Ainsi si une loco perd le contact et donc sa configuration, elle sera mise a jour lorsqu'elle retrouvera le contact.
	Les souris (ou logiciel PC) modifient ces slots suivant les actions de l'utilisateur.
	Lorsque une nouvelle loco est utilisée, celle ci est rajouté dans un slot disponible.
	S'il n'y a pas de slot dsiponible, la loco remplace la loco dont le slot a la plus vielle modification.

	pins:
					RST #### TX
		  SENCE -->  A0 #### RX
  DIN+DOUT/OUT1 <--  D0 #### D1  --> OUT0/LDIN
 AU + CLK /OUT2 <--  D5 #### D2  --> EN  +PWM
	  SDA /OUT3 <--  D6 #### D3  --> DCC +SENS             (PU)
	  SCK /OUT4 <--  D7 #### D4  --> LED (on board) / LLED (PU)
(PD) RSTIN/OUT5 <--  D8 #### GND
				   3.3V #### 5V

	gpio ds la datasheet de l'esp 8266
	- D0=GPIO16 / D1=GPIO5  / D2=GPIO4  / D3=GPIO0
	- D4=GPIO2  / D5=GPIO14 / D6=GPIO12 / D7=GPIO13
	- D8=GPIO15 / D9=GPIO3  / D1=GPIO1  / A0=NA

	durees des mises a jours:
	- in: 96bits @ 50us            -> 4.8ms
	- led: 2*8*16 = 256bits @ 10us -> 2.5ms
	- pca: 6*10bits @ 10us -> 0.6ms /ch
	- pca: 48* 0.6                 -> 29ms
	TOTAL: 36ms / 250ms

	protocoles:
	  D17        : Souris Android (simple et double), souris D17 JM (Windows,Linux), souris potentiometriques esp8266
	  DCC++ leger: RocRail
	  DS         : DesktopStation
	connexions:
			 OFF  D17  DCC++  DS
	  WIFI   oui  oui  ---    ---
	  USB    oui  ---  oui    oui

*/


#include "config.h"
#include "dcc.h"
#include "dccpp.h"
#include "dstation.h"
#include "i2c.h"
#include "inputs.h"
#include "leds.h"
#include "outputs.h"
#include "pca9685.h"
#include "protocol.h"
#include "signal.h"
#include "slot.h"
#include "tcpip.h"
#include "tempo.h"
#include "turnout.h"
#include "user.h"

#if PROTOCOLE == D17PPV2 || PROTOCOLE == D17PPV3
#include "speed.h"
#endif

#if PROTOCOLE == D17PPV3
#include "block.h"
#include "Zone.h"
#endif
/*
TIM_DIV1 = 0,   //80MHz (80 ticks/us - 104857.588 us max)
TIM_DIV16 = 1,  //5MHz (5 ticks/us - 1677721.4 us max)
TIM_DIV256 = 3 //312.5Khz (1 tick = 3.2us - 26843542.4 us max)


Ticker ticker;

void ICACHE_RAM_ATTR onTimerISR()
{
	timer1_write(600000);//12us
}

setup()
{
	//Initialize Ticker every 0.5s
	timer1_attachInterrupt(onTimerISR);
	timer1_enable(TIM_DIV16, TIM_EDGE, TIM_SINGLE);
	timer1_write(600000); //120000 us}
*/
//--------------------------------------------------------------------------------
// MAIN
//----------------------------------------------------------------------------------

static void check_au_pin(void)
{
#if USER_USE_AU == 1
	byte state;

	state = digitalRead(AU_PIN);
	pinMode(AU_PIN, INPUT_PULLUP);
	delayMicroseconds(5);
#if USER_AU_LEVEL == 0
	if (digitalRead(AU_PIN) == LOW) au = 1;
#else
	if (digitalRead(AU_PIN) == HIGH) au = 1;
#endif
	pinMode(AU_PIN, OUTPUT);
	digitalWrite(AU_PIN, state);
#endif  
}

static unsigned long time0;

void setup()
{
	// serial init
	Serial.begin(115200);
#if PROTOCOLE <= D17PPV3
	Serial.printf("\nHello from %s\n", CENTRAL_NAME);
#if USER_USE_S88
	Serial.println("S88 bus");
#endif
#if USER_USE_MAX
	Serial.println("SPI bus");
#endif
#if USER_USE_PCA
	Serial.println("I2C bus");
#endif
#elif PROTOCOLE == DCCPP
	Serial.printf("<iDCC++ %s ***>", CENTRAL_NAME);
#elif PROTOCOLE == DSTATION
	Serial.println("--------------------------------------");
	Serial.println("Desktop Station Interface with Arduino");
	Serial.println("--------------------------------------");
	Serial.println("100 Ready");
#elif PROTOCOLE == CDMRAIL
	Serial.println("<p1><iDCC++ BASE STATION FOR ARDUINO UNO / ARDUINO MOTOR SHIELD: V-1.2.1+S88.1 / Mar  1 2019 19:28:46><N0: SERIAL><X><X>");
#endif

#if PRINT_PACKET
	boosterloop = 0;
#endif

	// some variables init
	slots_init();

	out_init();
#if USER_USE_MAX == 1
	// led init
	led_init();
#endif

#if USER_USE_PCA == 1
	// i2c init
	i2c_init();
	pca9685_init();
#endif

#if USER_USE_S88 == 1 || USER_USE_MCPIN == 1
	// in init
	in_init();
#endif

	aig_init();
#if PROTOCOLE == D17PPV3
	Block::OnInit();
#else
	on_init();
#endif
#if USE_WIFI || USE_TRACER == 2
	wifi_init();
	Serial.print("waiting clients ...");
#endif
	time0 = millis();
}

static byte cpt_250ms = 0;
#if PROTOCOLE == D17PPV3
static bool user_tco_init = false;
#endif

void loop()
{
#if USER_USE_MAX == 1
	byte is_500ms;
#endif
#if PRINT_CAN == 1
	byte is_1s;
#endif
#if IS_2S == 1
	byte is_2s;
#endif
#if USER_USE_PCA == 1
	byte index = 0;
#endif
	unsigned long time1;
#if PROTOCOLE <= D17PPV3
#if USE_WIFI == 1
	// 1. GESTION DES CLIENTS WIFI
	parse_wifi_clients();
#endif
#elif PROTOCOLE == DCCPP || PROTOCOLE == CDMRAIL
	// 1.5. GESTION DU CLIENT DCC++ USB
	parse_usb_dccpp();
#elif PROTOCOLE == DSTATION
	// 1.6. GESTION DU CLIENT DESKTOP STATION
	parse_usb_desktop_station();
#endif
#if USE_TRACER == 2
	connect_tracer();
#endif
	// 2. GENERATION DES SIGAUX DU BOOSTER
	check_au_pin(); // to update AU before booster update
	booster_maj();  // update one client (max 4 locos and functions) 
#if PROTOCOLE == D17PPV2 || PROTOCOLE == D17PPV3
	if (Speed::m_fEnMesure) {
		// 6. LECTURE DES ENTREES S88
		if (!au) {
			in_maj();   //4.8ms
			if (boost == BOOST_DCC) dcc_keepalive();
			Speed::MesureVitesse();
		}
		yield();
		return;
	}
#endif
	// 3. GESTION DU TEMPS (TOUTES LES 250ms) (uu: essayer de reduire a 125ms)
	time1 = millis();
#if USE_TRACER
	if ((time1 - time0) > 300) Serial.print("#");
# if PRINT_TIME
	TRACER.println(time1 - time0);
# endif    
#endif
	if ((time1 - time0) < 250) return;
	time0 = time1;

	// on arrive ici toute les 250ms      
	cpt_250ms++;
#if USER_USE_MAX == 1
	is_500ms = ((cpt_250ms & 1) == 0);   // 1x/2
#endif
#if PRINT_CAN
	is_1s = ((cpt_250ms & 3) == 0);         // 1x/4
#endif
#if IS_2S
	is_2s = ((cpt_250ms & 7) == 0);         // 1x/8
#endif
	// 4. CLIGNOTEMENT DE LA LED (Sign of life) 
	if (!au) // lent 0.5Hz
	{
		led_sign_of_life(cpt_250ms & 4);
	}
	else // rapide 2Hz
	{
		led_sign_of_life(cpt_250ms & 1);
	}
	yield();

	// 5. LECTURE DU COURANT
	an = analogRead(A0);
#if PRINT_CAN == 1
	if (is_1s)
		TRACE1("can=%d\n", an);
#endif
	// 6. LECTURE DES ENTREES S88
#if USER_USE_S88 || USER_USE_MCPIN
	if (!au) {
		in_maj();   //4.8ms
		if (boost == BOOST_DCC) dcc_keepalive();
		yield();
	}
#endif
#if PROTOCOLE == DCCPP
	dccpp_in_send_diff(); //uu: semble ne pas marcher envoie tout le temps ...
#elif PROTOCOLE == CDMRAIL
	cdm_in_send_diff();
#endif

	// 7. APPEL DE LA FONCTION DE BOUCLE UTILISATEUR
	tempo_maj();

	if (! au)
#if PROTOCOLE == D17PPV3
		if (fUseBlock) {
			if (!user_tco_init) {
				Block::InitTco();
				Block::UpdateZones();
				user_tco_init = true;
			} else {
				Block::UpdateZones();
				Block::Reguler();
			}
		} else
#endif
			on_250ms();

		yield();

	// 8. MISE A JOUR DES LEDs
#if USER_USE_MAX == 1
	if (is_500ms) led_cpt++;
	led_maj();   //2.5ms
	if (boost == BOOST_DCC) dcc_keepalive();
#endif   //(yield ds les fonctions SPI)

	// 9. MISE A JOUR PWM et SRV du PCA9685
#if USER_USE_PCA == 1
	pca9685_slow_srv(); // compute positions for servos using slow movements
	index = 0;
	while (1) // total pca9685_maj lasts between 0 and 60ms, so we cut it to call process_packet() between
	{
		if (pca9685_maj(index)) break;  //return 1 when nothing else to update   0.6ms/ch

		index++;
		if ((index & 7) == 0)  //each 4.8ms
		{
			if (boost == BOOST_DCC) dcc_keepalive();
		}
	}
#endif //(yield ds les fonctions I2C)
#if PROTOCOLE <= D17PPV3
	// 10. DEMANDE DE MISE A JOUR DU MESSAGE DE STATUS
	status_tx[0] = '\0';
#endif
	yield();
}



