//------------------------------------------------------------------------------
// Module D17 par Ulysse Delmas-Bgue
// I2C (I2C fait a la main pour pouvoir utiliser une basse frequence et n'importe quelle patte)
//------------------------------------------------------------------------------

#pragma once

#include "config.h"

#if USER_USE_PCA || USER_USE_MCPIN

constexpr auto I2C_READ = 1;
constexpr auto I2C_WRITE = 0;

void i2c_init(void);
void i2c_start(void);
void i2c_stop(void);
bool i2c_wr_8(byte data);
byte i2c_rd_ack(void);
byte i2c_rd_8(void);
void i2c_wr_ack(byte ack);   //1=ack, 0=nack

#endif


