//--------------------------------------------------------------------------------
// Module D17 par Ulysse Delmas-Bgue
// Leds (128) via MAX7219 IC on SPI bus
//----------------------------------------------------------------------------------
#pragma once

#include "config.h"

#if USER_USE_MAX
constexpr auto IO_LED_NB = 128;

extern byte io_led[IO_LED_NB / 8];  // possibilite d'initialiser les valeurs
extern byte io_cli[IO_LED_NB / 8];  // ex led clignotante
extern byte io_pha[IO_LED_NB / 8];
extern byte led_cpt;

void user_led(byte num, byte val);
void user_led_cli(byte num, byte val);
void user_led_pha(byte num, byte val);
void led_maj(void);
void led_init(void);

#endif

void led_sign_of_life(byte val);
