//----------------------------------------------------------------------------------
// Module D17 par Jean-Michel Dubois
// MCP23017 input and output via bus I2C
//----------------------------------------------------------------------------------
#pragma once

#include "config.h"

#if USER_USE_MCPIN

void in_mcp23017_init(void);
void in_mcp23017_maj(void);

#endif

#if USER_USE_MCPOUT

constexpr auto MCP23017_OUT_PIN_OFFSET = 16;

void out_mcp23017_init(void);
void out_mcp23017(byte num, byte val);

#endif
