//--------------------------------------------------------------------------------
// Module D17 par Jean-Michel Dubois
// Commande des signaux sur modules D19/2 (32 signaux  deux feux),
// D19/4 (16 signaux  4 feux), D19/5 (8 signaux  3 feux et 8 signaux  5 feux)
//  base de MAX7219. Schmas tablis avec TCI4
//--------------------------------------------------------------------------------
#pragma once

#include "config.h"

#if USER_USE_D19

#include "signal.h"

class d19
{
public:
	d19();
	~d19();
	static void a2feux(Signal* pSignal);
	static void a3feux(Signal* pSignal);
	static void a4feux(Signal* pSignal);
	static void a5feux(Signal* pSignal);
	static void a2x3feux(Signal* pSignal);
};

#endif