//--------------------------------------------------------------------------------
// Module D17 par Ulysse Delmas-Bgue
// Aiguillages
//----------------------------------------------------------------------------------

#include "turnout.h"

byte io_aig_cmd[IO_AIG_NB];
byte io_aig_dir[IO_AIG_NB];
byte io_aig_dev[IO_AIG_NB];

void user_set_d_e(byte num, byte val_d, byte val_e)
{
    if(num >= IO_AIG_NB)
      return;
      
    io_aig_dir[num] = val_d;
    io_aig_dev[num] = val_e;
}


void aig_init(void)
{
    byte i;

    for(i = 0; i < IO_AIG_NB; i++)
    {
        io_aig_cmd[i] = 0;
        io_aig_dev[i] = 0;
        io_aig_dir[i] = 0; 
    }
}

byte user_get_aig(byte naig)
{
    if(naig >= IO_AIG_NB)
      return 0;
      
  return io_aig_dev[naig];
}

/*
void aig_maj(void)
{
    // stub pour tester
    byte i;
    for(i = 0; i < IO_AIG_NB; i++)
    {
        if(io_aig_cmd[i] == 1) io_aig_dev[i] = 1; else io_aig_dev[i] = 0;
        io_aig_dir[i] = io_aig_dev[i] ^ 1; 
    }
}
*/




